Package org.eclipse.rdf4j.federated.algebra

## Class FedXService

- java.lang.Object
- - org.eclipse.rdf4j.query.algebra.AbstractQueryModelNode
  - - org.eclipse.rdf4j.federated.algebra.FedXService

- All Implemented Interfaces:
    `Serializable`, `Cloneable`, `BoundJoinTupleExpr`, `GraphPatternGroupable`, `QueryModelNode`, `TupleExpr`, `VariableScopeChange`

      public class FedXService
      extends AbstractQueryModelNode
      implements TupleExpr, BoundJoinTupleExpr

  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected Service` | `expr` |
    `protected int` | `nTriples` |
    `protected QueryInfo` | `queryInfo` |
    `protected boolean` | `simple` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `FedXService​(Service expr, QueryInfo queryInfo)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `FedXService` | `clone()` | Returns a (deep) clone of this query model node.
    `Set<String>` | `getAssuredBindingNames()` | Gets the names of the bindings that are guaranteed to be present in the results produced by this tuple expression.
    `Set<String>` | `getBindingNames()` | Gets the names of the bindings that are, or can be, returned by this tuple expression when it is evaluated.
    `int` | `getFreeVarCount()` |
    `Collection<String>` | `getFreeVars()` |
    `int` | `getNumberOfTriplePatterns()` |
    `QueryInfo` | `getQueryInfo()` |
    `Service` | `getService()` |
    `boolean` | `isSimple()` |
    `<X extends Exception> void` | `visit​(QueryModelVisitor<X> visitor)` | Visits this node.
    `<X extends Exception> void` | `visitChildren​(QueryModelVisitor<X> visitor)` | Dummy implementation of `QueryModelNode.visitChildren(org.eclipse.rdf4j.query.algebra.QueryModelVisitor<X>)` that does nothing.

    - ### Methods inherited from class org.eclipse.rdf4j.query.algebra.AbstractQueryModelNode

      `getCostEstimate, getParentNode, getResultSizeActual, getResultSizeEstimate, getSignature, getTotalTimeNanosActual, isGraphPatternGroup, isVariableScopeChange, nullEquals, replaceChildNode, replaceNodeInList, replaceWith, setCostEstimate, setGraphPatternGroup, setParentNode, setResultSizeActual, setResultSizeEstimate, setTotalTimeNanosActual, setVariableScopeChange, toString`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.eclipse.rdf4j.query.algebra.QueryModelNode

      `equals, getCostEstimate, getParentNode, getResultSizeActual, getResultSizeEstimate, getSignature, getTotalTimeNanosActual, replaceChildNode, replaceWith, setCostEstimate, setParentNode, setResultSizeActual, setResultSizeEstimate, setTotalTimeNanosActual, toString`

- - ### Field Detail

    - #### expr

          protected Service expr

    - #### queryInfo

          protected transient QueryInfo queryInfo

    - #### simple

          protected boolean simple

    - #### nTriples

          protected int nTriples

  - ### Constructor Detail

    - #### FedXService

          public FedXService​(Service expr,
                             QueryInfo queryInfo)

  - ### Method Detail

    - #### getService

          public Service getService()

    - #### getQueryInfo

          public QueryInfo getQueryInfo()

    - #### getNumberOfTriplePatterns

          public int getNumberOfTriplePatterns()

    - #### isSimple

          public boolean isSimple()

    - #### getFreeVars

          public Collection<String> getFreeVars()

    - #### getFreeVarCount

          public int getFreeVarCount()

    - #### visit

          public <X extends Exception> void visit​(QueryModelVisitor<X> visitor)
                                           throws X extends Exception

      Description copied from interface: `QueryModelNode`
      Visits this node. The node reports itself to the visitor with the proper runtime type.
      Specified by:
        `visit` in interface `QueryModelNode`
      Throws:
        `X extends Exception`

    - #### visitChildren

          public <X extends Exception> void visitChildren​(QueryModelVisitor<X> visitor)
                                                   throws X extends Exception

      Description copied from class: `AbstractQueryModelNode`
      Dummy implementation of `QueryModelNode.visitChildren(org.eclipse.rdf4j.query.algebra.QueryModelVisitor<X>)` that does nothing. Subclasses should override this method when they have child nodes.
      Specified by:
        `visitChildren` in interface `QueryModelNode`
      Overrides:
        `visitChildren` in class `AbstractQueryModelNode`
      Throws:
        `X extends Exception`

    - #### clone

          public FedXService clone()

      Description copied from interface: `QueryModelNode`
      Returns a (deep) clone of this query model node. This method recursively clones the entire node tree, starting from this nodes.
      Specified by:
        `clone` in interface `QueryModelNode`
      Specified by:
        `clone` in interface `TupleExpr`
      Overrides:
        `clone` in class `AbstractQueryModelNode`
      Returns:
        A deep clone of this query model node.

    - #### getAssuredBindingNames

          public Set<String> getAssuredBindingNames()

      Description copied from interface: `TupleExpr`
      Gets the names of the bindings that are guaranteed to be present in the results produced by this tuple expression.
      Specified by:
        `getAssuredBindingNames` in interface `TupleExpr`
      Returns:
        A set of binding names.

    - #### getBindingNames

          public Set<String> getBindingNames()

      Description copied from interface: `TupleExpr`
      Gets the names of the bindings that are, or can be, returned by this tuple expression when it is evaluated.
      Specified by:
        `getBindingNames` in interface `TupleExpr`
      Returns:
        A set of binding names.